#include "adc.h"
#include <avr/io.h>


void
adc_init(void)
{
  ADMUX = 0;
  ADCSRA = 0;
  ADCSRB = 0;

  // Set clock to CLK/128=62.5kHz (conversion time ~200us)
  ADCSRA = _BV(ADPS2) | _BV(ADPS1) | _BV(ADPS0);
  // Left-aligned result
  // ADCSRB = _BV(ADLAR); // ATtiny84
  // ADMUX = _BV(ADLAR); // ATmega328p
  // Set reference to VCC
  ADMUX = 0; // ATtiny84
  // ADMUX |= _BV(REFS0); // ATmega328p
  // Enable ADC
  ADCSRA |= _BV(ADEN);
}


uint16_t
adc_sample(uint8_t channel)
{
  ADMUX &= 0xf0;
  ADMUX |= channel;
  ADCSRA |= _BV(ADSC);

  while (!(ADCSRA & _BV(ADIF)));

  uint16_t result = ADC;

  ADCSRA |= _BV(ADIF);
  TIFR1 |= _BV(ICF1);

  return result;
}
